﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Reflection;
using System.Text;

namespace LastFMLib
{
    public class BaseWService
    {
        public enum REQUEST_METHOD { GET, POST }

        public WebProxy Proxy { get; set; }

        public string UserAgent { get; set; }

        private UTF8Encoding utf8 = null;

        public const int REQUEST_TIMEOUT_MS = 4000;

        private string appver = null;        

        protected BaseWService()
        {
            Assembly assembly = Assembly.GetExecutingAssembly();
            appver = FileVersionInfo.GetVersionInfo(assembly.Location).ProductVersion.ToString();
            utf8 = new UTF8Encoding();
        }

        protected string GetUTF8(string value)
        {
            return utf8.GetString(Encoding.UTF8.GetBytes(value));
        }

        protected string GetResponseFromRequest(string url, REQUEST_METHOD method)
        {
            //string env = String.Format("{0} {1}", Environment.OSVersion.Platform.ToString(), Environment.OSVersion.VersionString);

            System.Net.HttpWebRequest request = (HttpWebRequest)(WebRequest.Create(new Uri(url)));
            request.Timeout = REQUEST_TIMEOUT_MS;
            //request.UserAgent = String.Format("{0}/{1} ({2}))", "Impulse Media Player", "test", "http://impulsemediaplayer.codeplex.com");
            request.UserAgent = UserAgent;
            request.Method = method.ToString();
            request.MaximumAutomaticRedirections = 4;
            request.MaximumResponseHeadersLength = 4;
            request.ContentLength = 0;

            StreamReader ReadStream = null;
            HttpWebResponse Response = null;
            string ResponseText = string.Empty;

            request.Proxy = this.Proxy;

            try
            {
                Response = (HttpWebResponse)(request.GetResponse());
                Stream ReceiveStream = Response.GetResponseStream();
                ReadStream = new StreamReader(ReceiveStream, System.Text.Encoding.UTF8);
                ResponseText = ReadStream.ReadToEnd();
                Response.Close();
                ReadStream.Close();

            }
            catch (Exception e)
            {
                ResponseText = string.Empty;
                throw e;
            }

            return ResponseText;
        }

    }
}
